﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using Arction.Wpf.SemibindableCharting;
using Arction.Wpf.SemibindableCharting.SeriesXY;
using Arction.Wpf.SemibindableCharting.Views.ViewXY;

namespace HeatmapTest
{
    public class MySeriesToIntensityGridSeriesCollectionConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (!(value is IList<MySeries>))
                return Binding.DoNothing;

            var mySes = (IList<MySeries>)value;
            var iSes = new IntensityGridSeriesCollection();

            foreach (var mSe in mySes)
            {
                var iSe = new IntensityGridSeries();
                iSe.PixelRendering = true;
                iSe.RangeMaxX = 100;
                iSe.RangeMaxY = 100;
                iSe.RangeMinX = 0;
                iSe.RangeMinX = 0;
                iSe.TraceMouseCell = true;
                //Something's weird...
                iSe.Data = ConvertIntesityPoint(mSe.Data);

                iSes.Add(iSe);
            };

            return iSes;

        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        private IntensityPoint[,] ConvertIntesityPoint(double[][] m_data)
        {
            int DataColumnCount = m_data[0].Length;
            int DataRowCount = m_data.Length;
            var result = new IntensityPoint[DataColumnCount, DataRowCount];
            for (int iCol = 0; iCol < DataColumnCount; iCol++)
            {
                for (int iRow = 0; iRow < DataRowCount; iRow++)
                {
                    result[iCol, iRow] = new IntensityPoint { Value = m_data[iCol][iRow] };
                }
            }
            return result;
        }
    }
}
